<?php
declare (strict_types = 1);

namespace app\admin\model\v1;

use app\common\model\ProductCategoryBaseModel;
use think\model\concern\SoftDelete;

/**
 * 产品分类模型
 * @mixin \think\Model
 */
class ProductCategoryModel extends ProductCategoryBaseModel
{
    // 启用软删除
    use SoftDelete;
    // 软件字段
    protected $deleteTime = 'deleted_at';

    // 根据pid查询
    public function scopePid($query, $pid)
    {
        $query->where('pid', '=', $pid);
    }

    // 所属语言查询
    public function scopeLanguage($query, $value)
    {
        $query->where('language_id', '=', $value);
    }

    // 所属产品目录分类id查询
    public function scopeTcoId($query, $value)
    {
        // $query->where('related_tco_category', '=', $value);
        $query->whereRaw('FIND_IN_SET(:ref_id, related_tco_category)', ['ref_id' => $value]);
    }

    /**
     * 根据是否显示查询
     * @param $query
     * @param \Closure:bool|bool $value
     */
    public function scopeIsShow($query, \Closure|bool $value)
    {
        if (is_callable($value)) {
            $query->where('is_show', '=', $value());
            return;
        }
        $query->where('is_show', '=', (int)$value);
    }

    // 搜索分类名称
    public function searchNameNullableAttr($query, $value, $data)
    {
        if (is_null($value)) {
            return;
        }
        $query->where('name', 'like', '%' . $value . '%');
    }
}
